package com.logicbig.example;

public abstract class Shape {
    private int x = 0;
    private int y = 0;

    public void setOrigin(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public void draw() {
        System.out.println("----");
        System.out.println("Drawing:");
        //Template method pattern
        drawShape();
        System.out.printf("At (%s, %s) %n", x, y);
        System.out.println("----");
    }

    protected abstract void drawShape();
}